# Hi there

Thanks for your interest in making the Monkey -- and therefore, your network -- a better place!

Are you about to report a bug? Sorry to hear it. Here's our [Issue tracker](https://github.com/guardicore/monkey/issues).
Please try to be as specific as you can about your problem; try to include steps
to reproduce. While we'll try to help anyway, focusing us will help us help you faster.

If you want to contribute new code or fix bugs..


## Submitting code

The following is a *short* list of recommendations. PRs that don't match these criteria won't be closed but it'll be harder to merge the changes into the code.

* **Do** stick to [PEP8](https://www.python.org/dev/peps/pep-0008/).
* **Do** target your pull request to the **develop branch**. 
* **Do** specify a descriptive title to make searching for your pull request easier.
* **Do** list verification steps so your code is testable.
* **Don't** leave your pull request description blank.
* **Do** license your code as GPLv3.

Also, please submit PRs to the develop branch.

## Issues
* **Do** write a detailed description of your bug and use a descriptive title.
* **Do** include reproduction steps, stack traces, and anything else that might help us verify and fix your bug.

Thank you for reading this before opening an issue or a PR, you've already doing good!
