from abc import ABCMeta, abstractmethod
import infection_monkey.config

__author__ = 'itamar'


class HostExploiter(object):
    __metaclass__ = ABCMeta

    _TARGET_OS_TYPE = []

    def __init__(self, host):
        self._config = infection_monkey.config.WormConfiguration
        self._exploit_info = {}
        self._exploit_attempts = []
        self.host = host

    def is_os_supported(self):
        return self.host.os.get('type') in self._TARGET_OS_TYPE

    def send_exploit_telemetry(self, result):
        from infection_monkey.control import ControlClient
        ControlClient.send_telemetry(
            'exploit',
            {'result': result, 'machine': self.host.__dict__, 'exploiter': self.__class__.__name__,
             'info': self._exploit_info, 'attempts': self._exploit_attempts})

    def report_login_attempt(self, result, user, password='', lm_hash='', ntlm_hash='', ssh_key=''):
        self._exploit_attempts.append({'result': result, 'user': user, 'password': password,
                                       'lm_hash': lm_hash, 'ntlm_hash': ntlm_hash, 'ssh_key': ssh_key})

    @abstractmethod
    def exploit_host(self):
        raise NotImplementedError()


from infection_monkey.exploit.win_ms08_067 import Ms08_067_Exploiter
from infection_monkey.exploit.wmiexec import WmiExploiter
from infection_monkey.exploit.smbexec import SmbExploiter
from infection_monkey.exploit.rdpgrinder import RdpExploiter
from infection_monkey.exploit.sshexec import SSHExploiter
from infection_monkey.exploit.shellshock import ShellShockExploiter
from infection_monkey.exploit.sambacry import SambaCryExploiter
from infection_monkey.exploit.elasticgroovy import ElasticGroovyExploiter
from infection_monkey.exploit.struts2 import Struts2Exploiter
from infection_monkey.exploit.weblogic import WebLogicExploiter
from infection_monkey.exploit.hadoop import HadoopExploiter
from infection_monkey.exploit.mssqlexec import MSSQLExploiter
